#ifndef JMT1808R_REG_H
#define JMT1808R_REG_H

//ALL PAGE
   sfr P0               = 0x80;
   sfr SP               = 0x81;
   sfr DPL              = 0x82;
   sfr DPH              = 0x83;
   sfr MOVXCON          = 0x86;
   sfr P1               = 0x90;
   sfr P2               = 0xA0;
   sfr IEN0             = 0xA8;
   sfr P3               = 0xB0;
   sfr IEN1             = 0xB8;
   sfr IEN2             = 0xC0;
   sfr P4               = 0xC8;
   sfr PSW              = 0xD0;
   sfr IP0              = 0xD8;
   sfr ACC              = 0xE0;
   sfr IP1              = 0xE8;
   sfr B                = 0xF0;
   sfr IP2              = 0xF8;
   sfr SFRPGEN          = 0x85;
   sfr SFRPAGE          = 0x84;

//PAGE0
   sfr TCON             = 0x88;
   sfr TMOD             = 0x89;
   sfr TL0              = 0x8A;
   sfr TL1              = 0x8B;
   sfr TH0              = 0x8C;
   sfr TH1              = 0x8D;
   sfr TPSC             = 0x8E;
   sfr S0CON            = 0x98;
   sfr S0BUF            = 0x99;
   sfr S0RELL           = 0x9A;
   sfr S0RELH           = 0x9B;
   sfr S0IRCON          = 0x9C;
   sfr RTCCON0          = 0xA9;
   sfr RTCCON1          = 0xAA;
   sfr RTCTMC           = 0xAB;
   sfr RTCSEC           = 0xAC;
   sfr RTCMIN           = 0xAD;
   sfr RTCHOUR          = 0xAE;
   sfr RTCWEEK          = 0xAF;
   sfr RTCDAY           = 0xB1;
   sfr RTCMON           = 0xB2;
   sfr RTCYEAR          = 0xB3;
   sfr AL0SEC           = 0xB4;
   sfr AL0MIN           = 0xB5;
   sfr AL0HOUR          = 0xB6;
   sfr AL0WEEKS         = 0xB7;
   sfr AL1MIN           = 0xB9;
   sfr AL1HOUR          = 0xBA;
   sfr AL1DAY           = 0xBB;
   sfr AL1MON           = 0xBC;
   sfr RTCADJ0          = 0xBD;
   sfr RTCADJ1          = 0xBE;
   sfr RTCIE            = 0xBF;
   sfr RTCIF            = 0xC7;
   sfr SPICON           = 0xC9;
   sfr SPIIE            = 0xCA;
   sfr SPIIF            = 0xCB;
   sfr SPIBR            = 0xCC;
   sfr SPIBUF           = 0xCD;
   sfr T2CON            = 0xD1;
   sfr RL2              = 0xD2;
   sfr RH2              = 0xD3;
   sfr TL2              = 0xD4;
   sfr TH2              = 0xD5;
   sfr T2PSC            = 0xD6;
   sfr I2CCON           = 0xE1;
   sfr I2CSADDRL        = 0xE2;
   sfr I2CSADDRH        = 0xE3;
   sfr I2COADDRL        = 0xE4;
   sfr I2COADDRH        = 0xE5;
   sfr I2CDIV           = 0xE6;
   sfr I2CDUTYL         = 0xE7;
   sfr I2CDUTYH         = 0xE9;
   sfr I2CHOLD          = 0xEA;
   sfr I2CWBUF          = 0xEB;
   sfr I2CRBUF          = 0xEC;
   sfr I2CSTS           = 0xED;
   sfr I2CISC           = 0xEE;
   sfr I2CIEN           = 0xEF;
   sfr S1CON            = 0xF1;
   sfr S1BUF            = 0xF2;
   sfr S1RELL           = 0xF3;
   sfr S1RELH           = 0xF4;
   sfr S1IRCON          = 0xF5;
   sfr FLSC             = 0xF9;
   sfr FLSK             = 0xFA;
   sfr FLSM             = 0xFB;

   sfr CMPEN            = 0x91;
   sfr CMPINT           = 0x92;
   sfr CMPFLAG          = 0x93;
   sfr CMPFT            = 0x94;
   sfr CMPVDD           = 0x95;
   sfr CMPREF           = 0x96;
   sfr CMPTEST          = 0x97;

   sfr WDTCKDIV         = 0xD9;
   sfr WDTINT           = 0xDA;
   sfr WDTINTF          = 0xDB;
   sfr WDTLD            = 0xDC;
   sfr WDTST            = 0xDD;

   sfr PMUCTR           = 0xA1;
   sfr PMUPD            = 0xA2;
   sfr PMUDBG           = 0xA3;
   sfr DLYH73M          = 0xA4;
   sfr DLYL73M          = 0xA5;


//PAGE1
   sfr ADC0CON          = 0x88;
   sfr ADC0IE           = 0x89;
   sfr ADC0IF           = 0x8A;
   sfr ADC0WDC          = 0x8B;
   sfr ADC0HTL          = 0x8C;
   sfr ADC0HTH          = 0x8D;
   sfr ADC0LTL          = 0x8E;
   sfr ADC0LTH          = 0x8F;

   sfr ADC0QLC          = 0x91;
   sfr ADC0NQTC         = 0x92;
   sfr ADC0NQ0          = 0x93;
   sfr ADC0NQ1          = 0x94;
   sfr ADC0NQ2          = 0x95;
   sfr ADC0NQ3          = 0x96;
   sfr ADC0NQ4          = 0x97;

   sfr ADC1CON          = 0x98;
   sfr ADC0NQ5          = 0x99;
   sfr ADC0NRL          = 0x9A;
   sfr ADC0NRH          = 0x9B;
   sfr ADC0SQTC         = 0x9C;
   sfr ADC0SQ0          = 0x9D;
   sfr ADC0SQ1          = 0x9E;
   sfr ADC0SR0L         = 0x9F;

   sfr ADC0SR0H         = 0xA1;
   sfr ADC0SR1L         = 0xA2;
   sfr ADC0SR1H         = 0xA3;
   sfr ADC0SR2L         = 0xA4;
   sfr ADC0SR2H         = 0xA5;
   sfr ADC0SR3L         = 0xA6;
   sfr ADC0SR3H         = 0xA7;

   sfr ADC0DF           = 0xA9;
   sfr ADCDMC           = 0xAA;
   sfr ADCJC            = 0xAB;
   sfr ADC0PGAC         = 0xAC;
   sfr ADC0ETC          = 0xAD;
   sfr ADC0NQTD         = 0xAE;
   sfr ADC0SQTD         = 0xAF;

   sfr ADC1IE           = 0xC1;
   sfr ADC1IF           = 0xC2;
   sfr ADC1WDC          = 0xC3;
   sfr ADC1HTL          = 0xC4;
   sfr ADC1HTH          = 0xC5;
   sfr ADC1LTL          = 0xC6;
   sfr ADC1LTH          = 0xC7;

   sfr ADC1QLC          = 0xC9;
   sfr ADC1NQTC         = 0xCA;
   sfr ADC1NQ0          = 0xCB;
   sfr ADC1NQ1          = 0xCC;
   sfr ADC1NQ2          = 0xCD;
   sfr ADC1NQ3          = 0xCE;
   sfr ADC1NQ4          = 0xCF;

   sfr ADC1NQ5          = 0xD1;
   sfr ADC1NRL          = 0xD2;
   sfr ADC1NRH          = 0xD3;
   sfr ADC1SQTC         = 0xD4;
   sfr ADC1SQ0          = 0xD5;
   sfr ADC1SQ1          = 0xD6;
   sfr ADC1SR0L         = 0xD7;

   sfr ADC1SR0H         = 0xD9;
   sfr ADC1SR1L         = 0xDA;
   sfr ADC1SR1H         = 0xDB;
   sfr ADC1SR2L         = 0xDC;
   sfr ADC1SR2H         = 0xDD;
   sfr ADC1SR3L         = 0xDE;
   sfr ADC1SR3H         = 0xDF;

   sfr ADC1DF           = 0xE1;
   sfr ADC1PGAC         = 0xE4;
   sfr ADC1ETC          = 0xE5;
   sfr ADC1NQTD         = 0xE6;
   sfr ADC1SQTD         = 0xE7;

//PAGE2
   sfr P5               = 0x88;
   sfr P6               = 0x98;
   sfr PA0CTRL          = 0x99;
   sfr PA1CTRL          = 0x9A;
   sfr PA2CTRL          = 0x9B;
   sfr PA3CTRL          = 0x9C;
   sfr PA4CTRL          = 0x9D;
   sfr PA5CTRL          = 0x9E;
   sfr PA6CTRL          = 0x9F;

   sfr PB0CTRL          = 0xA1;
   sfr PB1CTRL          = 0xA2;
   sfr PB2CTRL          = 0xA3;
   sfr PB3CTRL          = 0xA4;
   sfr PB4CTRL          = 0xA5;
   sfr PB5CTRL          = 0xA6;
   sfr PB6CTRL          = 0xA7;

   sfr PC0CTRL          = 0xA9;
   sfr PC1CTRL          = 0xAA;
   sfr PC2CTRL          = 0xAB;
   sfr PC3CTRL          = 0xAC;
   sfr PC4CTRL          = 0xAD;
   sfr PC5CTRL          = 0xAE;
   sfr PC6CTRL          = 0xAF;

   sfr PD0CTRL          = 0xB1;
   sfr PD1CTRL          = 0xB2;
   sfr PD2CTRL          = 0xB3;
   sfr PD3CTRL          = 0xB4;
   sfr PD4CTRL          = 0xB5;
   sfr PD5CTRL          = 0xB6;
   sfr PD6CTRL          = 0xB7;

   sfr PE0CTRL          = 0xB9;
   sfr PE1CTRL          = 0xBA;
   sfr PE2CTRL          = 0xBB;
   sfr PE3CTRL          = 0xBC;
   sfr PE4CTRL          = 0xBD;
   sfr PE5CTRL          = 0xBE;
   sfr PE6CTRL          = 0xBF;

   sfr PG0CTRL          = 0xC1;
   sfr PG1CTRL          = 0xC2;
   sfr PA7CTRL          = 0xC3;
   sfr PB7CTRL          = 0xC4;
   sfr PC7CTRL          = 0xC5;
   sfr PD7CTRL          = 0xC6;
   sfr PE7CTRL          = 0xC7;

   sfr PASR             = 0xC9;
   sfr PBSR             = 0xCA;
   sfr PCSR             = 0xCB;
   sfr PDSR             = 0xCC;
   sfr PESR             = 0xCD;
   sfr PGSR             = 0xCE;
   sfr AIOEN0           = 0xCF;

   sfr PADR             = 0xD1;
   sfr PBDR             = 0xD2;
   sfr PCDR             = 0xD3;
   sfr PDDR             = 0xD4;
   sfr PEDR             = 0xD5;
   sfr PGDR             = 0xD6;
   sfr AIOEN1           = 0xD7;

   sfr NRSTFQS          = 0xD9;
   sfr WKUPF            = 0xDA;
   sfr WKUPEN           = 0xDB;
   sfr INT0PE           = 0xDC;
   sfr INT0NE           = 0xDD;
   sfr INT0EN           = 0xDE;
   sfr INT0CON          = 0xDF;

   sfr INT1PE           = 0xE1;
   sfr INT1NE           = 0xE2;
   sfr INT1EN           = 0xE3;
   sfr INT1CON          = 0xE4;
   sfr INT1SEL0         = 0xE5;
   sfr INT1SEL1         = 0xE6;
   sfr INT1SEL2         = 0xE7;

   sfr INT1SEL3         = 0xE9;
   sfr PWMBKS           = 0xEA;
   sfr DBGCON0          = 0xEB;
   sfr DBGCON1          = 0xEC;

   sfr PWMOSEL          = 0xF1;
   sfr PWMOSEL0         = 0xF2;
   sfr PWMOSEL1         = 0xF3;
   sfr PWMOSEL2         = 0xF4;
   sfr PWMOMUX0         = 0xF5;
   sfr PWMOMUX1         = 0xF6;
   sfr PWMOMUX2         = 0xF7;

   sfr PAIE             = 0xF9;
   sfr PBIE             = 0xFA;
   sfr PCIE             = 0xFB;
   sfr PDIE             = 0xFC;
   sfr PEIE             = 0xFD;
   sfr PGIE             = 0xFE;

   sfr PGSTACK0         = 0x91;
   sfr PGSTACK1         = 0x92;
   sfr PGSTACK2         = 0x93;
   sfr PGSTACK3         = 0x94;

//PAGE3
   sfr GPIO_CLK_DIV     = 0xB2;

   sfr CLK_EN1          = 0xA9;
   sfr CLK_EN2          = 0xAA;
   sfr SPI_CLK_DIV      = 0xAB;
   sfr I2C_CLK_DIV      = 0xAC;
   sfr PWM0_CLK_DIV     = 0xAD;
   sfr PWM1_CLK_DIV     = 0xAE;

   sfr CMP_CLK_CTRL     = 0xB1;
   sfr EXTCLK_DIVL      = 0x8A;
   sfr EXTCLK_DIVH      = 0x8B;
   sfr SYS_CLK_SEL      = 0x8C;
   sfr ADC_CLK_DIV      = 0x8D;
   sfr RTC_CLK_CTRL     = 0x8E;
   sfr SYS_CLK_DIV      = 0x8F;

   sfr CLK_EN0          = 0x91;
   sfr SWRST0           = 0x93;
   sfr SWRST1           = 0x94;
   sfr GLOBALRST        = 0x95;
   sfr RSTFLAG          = 0x96;
   sfr TRMVAL72M        = 0x97;

   sfr TRMVAL32K        = 0x99;
   sfr CRMCTRL          = 0x9A;

   sfr OSCPD            = 0x9E;
   sfr CLKOUTCTRL       = 0x9F;

   sfr BANDGAP_CTRL     = 0xA3;
   sfr OSC_STABL        = 0xA4;
   sfr OSC_STABH        = 0xA5;
   sfr CLK_READY        = 0xA6;
   sfr OSCEN            = 0xA7;

   sfr ADCTRIM          = 0x87;

   sfr X0_REG_LOW       = 0xB9;
   sfr X0_REG_HIGH      = 0xBA;
   sfr Y0_REG_LOW       = 0xBB;
   sfr Y0_REG_HIGH      = 0xBC;
   sfr Z0_REG_LOW       = 0xBD;
   sfr Z0_REG_HIGH      = 0xBE;

   sfr XN_REG_LOW       = 0xC1;
   sfr XN_REG_HIGH      = 0xC2;
   sfr YN_REG_LOW       = 0xC3;
   sfr YN_REG_HIGH      = 0xC4;
   sfr ZN_REG_LOW       = 0xC5;
   sfr ZN_REG_HIGH      = 0xC6;

   sfr CORDIC_START     = 0xC8;
   sfr CORDIC_MODE      = 0xC9;
   sfr CORDIC_STATUS    = 0xCA;
   sfr CORDIC_INT       = 0xCB;


   sfr DSP_STA          = 0xD1;
   sfr DSP_PCL          = 0xD2;
   sfr DSP_PCH          = 0xD3;
   sfr DSP_CFG          = 0xD4;

   sfr DSP_R0L          = 0xD9;
   sfr DSP_R0H          = 0xDA;
   sfr DSP_R1L          = 0xDB;
   sfr DSP_R1H          = 0xDC;
   sfr DSP_R2L          = 0xDD;
   sfr DSP_R2H          = 0xDE;
   sfr DSP_R3L          = 0xDF;

   sfr DSP_R3H          = 0xE1;
   sfr DSP_R4L          = 0xE2;
   sfr DSP_R4H          = 0xE3;
   sfr DSP_R5L          = 0xE4;
   sfr DSP_R5H          = 0xE5;
   sfr DSP_R6L          = 0xE6;
   sfr DSP_R6H          = 0xE7;

   sfr DSP_R7L          = 0xE9;
   sfr DSP_R7H          = 0xEA;
   sfr DSP_DP0L         = 0xEB;
   sfr DSP_DP0H         = 0xEC;
   sfr DSP_DP1L         = 0xED;
   sfr DSP_DP1H         = 0xEE;
   sfr DSP_A0L          = 0xEF;

   sfr DSP_A0H          = 0xF1;
   sfr DSP_A1L          = 0xF2;
   sfr DSP_A1H          = 0xF3;
   sfr DSP_A2L          = 0xF4;
   sfr DSP_LNKRL        = 0xF5;
   sfr DSP_LNKRH        = 0xF6;
   sfr DSP_PSRL         = 0xF7;

   sfr DSP_PSRH         = 0xF9;
   sfr DSP_PMRL         = 0xFA;
   sfr DSP_PMRH         = 0xFB;
   sfr DSP_LOOPL        = 0xFC;
   sfr DSP_LOOPH        = 0xFD;
   sfr DSP_LIRL         = 0xFE;
   sfr DSP_LIRH         = 0xFF;


//PAGE4
   sfr TIM0_CONR0       = 0xBB;

   sfr TIM0_CONR1       = 0x89;
   sfr TIM0_CONR2       = 0x8A;
   sfr TIM0_CONR3       = 0x8B;
   sfr TIM0_TGICR0      = 0x8C;
   sfr TIM0_TGICR1      = 0x8D;
   sfr TIM0_IER         = 0x8E;
   sfr TIM0_CC0MR       = 0x8F;

   sfr TIM0_CC1MR       = 0x91;
   sfr TIM0_CC2MR       = 0x92;
   sfr TIM0_CC3MR       = 0x93;
   sfr TIM0_CCENR       = 0x94;
   sfr TIM0_CCPS        = 0x95;
   sfr TIM0_DTC         = 0x96;
   sfr TIM0_ARRL        = 0x97;

   sfr TIM0_ARRH        = 0x99;
   sfr TIM0_PSCL        = 0x9A;
   sfr TIM0_PSCH        = 0x9B;
   sfr TIM0_RCR         = 0x9C;
   sfr TIM0_CC0RUL      = 0x9D;
   sfr TIM0_CC0RUH      = 0x9E;
   sfr TIM0_CC0RDL      = 0x9F;

   sfr TIM0_CC0RDH      = 0xA1;
   sfr TIM0_CC1RUL      = 0xA2;
   sfr TIM0_CC1RUH      = 0xA3;
   sfr TIM0_CC1RDL      = 0xA4;
   sfr TIM0_CC1RDH      = 0xA5;
   sfr TIM0_CC2RUL      = 0xA6;
   sfr TIM0_CC2RUH      = 0xA7;

   sfr TIM0_CC2RDL      = 0xA9;
   sfr TIM0_CC2RDH      = 0xAA;
   sfr TIM0_CC3RUL      = 0xAB;
   sfr TIM0_CC3RUH      = 0xAC;
   sfr TIM0_CC3RDL      = 0xAD;
   sfr TIM0_CC3RDH      = 0xAE;
   sfr TIM0_BRKC        = 0xAF;

   sfr TIM0_EGR         = 0xB1;
   sfr TIM0_CMPLMTARY   = 0xB2;
   sfr TIM0_ISR0        = 0xB3;
   sfr TIM0_ISR1        = 0xB4;
   sfr TIM0_CNTL        = 0xB5;
   sfr TIM0_CNTH        = 0xB6;
   sfr TIM0_IER_NOCMP   = 0xB7;

   sfr TIM0_ISR2        = 0xB9;
   sfr TIM0_TESTPIN_SEL  =0xBA;

   sfr TIM1_CONR0       = 0xFB;

   sfr TIM1_CONR1       = 0xC9;
   sfr TIM1_CONR2       = 0xCA;
   sfr TIM1_CONR3       = 0xCB;
   sfr TIM1_TGICR0      = 0xCC;
   sfr TIM1_TGICR1      = 0xCD;
   sfr TIM1_IER         = 0xCE;
   sfr TIM1_CC0MR       = 0xCF;

   sfr TIM1_CC1MR       = 0xD1;
   sfr TIM1_CC2MR       = 0xD2;
   sfr TIM1_CC3MR       = 0xD3;
   sfr TIM1_CCENR       = 0xD4;
   sfr TIM1_CCPS        = 0xD5;
   sfr TIM1_DTC         = 0xD6;
   sfr TIM1_ARRL        = 0xD7;

   sfr TIM1_ARRH        = 0xD9;
   sfr TIM1_PSCL        = 0xDA;
   sfr TIM1_PSCH        = 0xDB;
   sfr TIM1_RCR         = 0xDC;
   sfr TIM1_CC0RUL      = 0xDD;
   sfr TIM1_CC0RUH      = 0xDE;
   sfr TIM1_CC0RDL      = 0xDF;

   sfr TIM1_CC0RDH      = 0xE1;
   sfr TIM1_CC1RUL      = 0xE2;
   sfr TIM1_CC1RUH      = 0xE3;
   sfr TIM1_CC1RDL      = 0xE4;
   sfr TIM1_CC1RDH      = 0xE5;
   sfr TIM1_CC2RUL      = 0xE6;
   sfr TIM1_CC2RUH      = 0xE7;

   sfr TIM1_CC2RDL      = 0xE9;
   sfr TIM1_CC2RDH      = 0xEA;
   sfr TIM1_CC3RUL      = 0xEB;
   sfr TIM1_CC3RUH      = 0xEC;
   sfr TIM1_CC3RDL      = 0xED;
   sfr TIM1_CC3RDH      = 0xEE;
   sfr TIM1_BRKC        = 0xEF;

   sfr TIM1_EGR         = 0xF1;
   sfr TIM1_CMPLMTARY   = 0xF2;
   sfr TIM1_ISR0        = 0xF3;
   sfr TIM1_ISR1        = 0xF4;
   sfr TIM1_CNTL        = 0xF5;
   sfr TIM1_CNTH        = 0xF6;
   sfr TIM1_IER_NOCMP   = 0xF7;

   sfr TIM1_ISR2        = 0xF9;



//// SBIT
//TCON 0x88
   sbit TF1             = 0x8F;                   // Timer1 overflow flag
   sbit TR1             = 0x8E;                   // Timer1 on/off control
   sbit TF0             = 0x8D;                   // Timer0 overflow flag
   sbit TR0             = 0x8C;                   // Timer0 on/off control

//S0CON 0x98
   sbit SM00            = 0x9F;                   // Serial mode control bit 0
   sbit SM10            = 0x9E;                   // Serial mode control bit 1
   sbit SM20            = 0x9D;                   // Multiprocessor communication enable
   sbit REN0            = 0x9C;                   // Receive enable
   sbit TB80            = 0x9B;                   // Transmit bit 8
   sbit RB80            = 0x9A;                   // Receive bit 8
   sbit TI0             = 0x99;                   // Transmit interrupt flag
   sbit RI0             = 0x98;                   // Receive interrupt flag

//IEN0 0xA8
   sbit EA              = 0xAF;                   // Global interrupt enable
   sbit INT8            = 0xAD;                   // External interrupt 8 enable
   sbit ES              = 0xAC;                   // UART0 interrupt enable
   sbit ET1             = 0xAB;                   // Timer1 interrupt enable
   sbit INT1            = 0xAA;                   // External interrupt 1 enable
   sbit ET0             = 0xA9;                   // Timer0 interrupt enable
   sbit INT0            = 0xA8;                   // External interrupt 0 enable

//PSW 0xE8
   sbit CY              = 0xEF;                   // Carry flag
   sbit AC              = 0xEE;                   // Auxiliary carry flag
   sbit F0              = 0xED;                   // User flag 0
   sbit RS1             = 0xEC;                   // Register bank select 1
   sbit RS0             = 0xEB;                   // Register bank select 0
   sbit OV              = 0xEA;                   // Overflow flag
   sbit F1              = 0xE9;                   // User flag 1
   sbit P               = 0xE8;                   // Accumulator parity flag

#endif
